using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.Security.Entity
 {
    [TypeScript]
    [Table("security_group")]
    public class SecurityGroupEntity : EntityBase<string>
    {

    public SecurityGroupEntity() 
    {
    }

    [Column("created_datetime")]
    public DateTime CreatedDatetime  { get; set; }
    [Column("created_by")]
    public string CreatedBy  { get; set; }
    [Column("updated_datetime")]
    public DateTime UpdatedDatetime  { get; set; }
    [Column("updated_by")]
    public string UpdatedBy  { get; set; }
    [Key]
    [Column("group_name")]
    public string GroupName  { get; set; }
    [Column("group_local_name")]
    public string? GroupLocalName  { get; set; }
    [Column("group_eng_name")]
    public string? GroupEngName  { get; set; }

    public const string CREATED_DATETIME = "CreatedDatetime";
    public const string CREATED_BY = "CreatedBy";
    public const string UPDATED_DATETIME = "UpdatedDatetime";
    public const string UPDATED_BY = "UpdatedBy";
    public const string GROUP_NAME = "GroupName";
    public const string GROUP_LOCAL_NAME = "GroupLocalName";
    public const string GROUP_ENG_NAME = "GroupEngName";

    public const string DB_NAME_SECURITY_GROUP = "security_group";
    public const string DB_NAME_FIELDS="created_datetime,created_by,updated_datetime,updated_by,group_name,group_local_name,group_eng_name";

    public const string DB_CREATED_DATETIME = "created_datetime";
    public const string DB_CREATED_BY = "created_by";
    public const string DB_UPDATED_DATETIME = "updated_datetime";
    public const string DB_UPDATED_BY = "updated_by";
    public const string DB_GROUP_NAME = "group_name";
    public const string DB_GROUP_LOCAL_NAME = "group_local_name";
    public const string DB_GROUP_ENG_NAME = "group_eng_name";


    public static SecurityGroupEntity GetInstance()
    {
        return new SecurityGroupEntity();
    }

    public virtual void CopyFrom(SecurityGroupEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(SecurityGroupEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        this.GroupName =  source.GroupName;
        this.GroupLocalName =  source.GroupLocalName;
        this.GroupEngName =  source.GroupEngName;

        if (includeSystemFields)
        {
        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_SECURITY_GROUP}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_SECURITY_GROUP}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
            if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_GROUP_NAME ;  		
		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_SECURITY_GROUP}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public SecurityGroupEntity Clone()
    {
        SecurityGroupEntity result = new SecurityGroupEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
